/**
 * @file	    _dsr.c
 * @brief		DSR source file
 * @version		1.0
  
 */



#include <stdint.h>
#include <string.h>
#include "ScatterWeb.System.h"
#include "ScatterWeb.CC1020.h"
#include "_dsr.h"




void Net_sendArgsInit_1(netpacket_send_args_t* args)
{
	memset(args, 0, sizeof(netpacket_send_args_t)); // clear struct
	args->netheader.from = Configuration.id; // this node's address
	args->netheader.flags = NET_TLFLAG_ACKREQ; // network layer config flags
}




enum netaddr_compareresult
Net_compareAddress_1(const netaddr_t (*const adr), const bool directConnection)
{
	if (*adr == Configuration.id)
		return ADRCOMP_THIS;

	if (directConnection) {
		if( (*adr == 0) )
			return ADRCOMP_THIS;
	} else if( *adr == 0 )
	        return ADRCOMP_ERROR;
	if( *adr == MY_BROADCAST )
		return ADRCOMP_BROADCAST;
	else
     	return ADRCOMP_OTHER;
 
}


// IMPLEMENTATION OF DSR PROTOCOL FUNCTIONS


/**
////////////////////////////////////////////////////////////////////////////////
/////////////////////////Route-Discovery////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/
bool Route_discovery(netaddr_t dest) {


Net_sendRequest(dest);

}
/**
////////////////////////////////////////////////////////////////////////////////
/////////////To decisions request further send or reply/////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/
bool Net_sendDecides(netaddr_t dest,uint8_t counter,uint8_t feld []) {
     
     bool wahr =true;
     bool weiter =true;
     uint8_t *pointer;
     pointer=feld;
     
	if(dest == Configuration.id)
	{
           Net_sendReply(dest,counter,feld);
            
    }else{  
            //if Id in list is then printf("My id is in Array ")
            while(wahr){
            if(*pointer!=0){
                 if(*pointer == Configuration.id){
                  printf("My id is in Array %d\n"); 
                  wahr=false;
                  weiter = false;         
                 }          
                 *pointer++;
             }
             wahr =false;
         }
      while(weiter){   
       handle_Request(dest,counter,feld); 
       weiter = false;  
       }
    }
}



/**
////////////////////////////////////////////////////////////////////////////////
///////////////////////Send Request/////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/
bool Net_sendRequest(netaddr_t dest) {
	netpacket_send_args_t npsargs;
	
    
	// fill structure with default values
	Net_sendArgsInit_1( &npsargs );

    
  
   // Array with 0 initialize
    uint8_t i; 
    for(i=0;i<=ARRAYLAENGE;i++){
    
             npsargs.netheader.away[i]=0; 
                                                                       
    }
    
    // The first place from array Source Id write
    uint8_t counter1 = 0;
    
    npsargs.netheader.away[0]=Configuration.id;
    counter1++;    
     
     
     // Send counter
    npsargs.netheader.counter = counter1;
 
    // Send destination
    npsargs.netheader.destination = dest;   
    // Braodcast         
	npsargs.netheader.to = ((netaddr_t)MY_BROADCAST); 
	npsargs.netheader.type = DSR_REQUEST_PACKET;	// application protocol
	npsargs.netheader.flags = 0;					// network layer config flags (CRC

    
    

	// queue packet for sending
	return Net_send( &npsargs );
}


/**
////////////////////////////////////////////////////////////////////////////////
//////////////////////Send Request further//////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/

bool handle_Request (netaddr_t dest,uint8_t counter,uint8_t feld[]){
     netpacket_send_args_t npsargs;


Net_sendArgsInit_1( &npsargs );


uint8_t *pointer;
pointer= feld;


uint8_t j; 
    for(j=0;j<=ARRAYLAENGE;j++){
               if(npsargs.netheader.away[j]==0){
                npsargs.netheader.away[j]=*pointer;                                        
                break;
               }                                                           
    }  


uint8_t counter1;
counter1=counter;
// Send Destionation
npsargs.netheader.destination = dest;


//----fill Array-----
	
    uint8_t x;
    for(x=0;x<=ARRAYLAENGE;x++){
        if(feld[x]==0){
              feld[x] = Configuration.id;
              break;
            }     
     
     }
//   send array     
     uint8_t s=0;
     uint8_t k;
     for(k=0; k<=ARRAYLAENGE; k++){
         npsargs.netheader.away[s]=feld[k];     
         s++;     
    }                  

	


counter1++;
npsargs.netheader.counter=counter1;

//--Send further----
     
  npsargs.netheader.to =((netaddr_t)MY_BROADCAST); 
                     
   

    npsargs.netheader.type = DSR_REQUEST_PACKET;	// application protocol
	npsargs.netheader.flags = 0;					// network layer config flags (CRC
   
    return Net_send( &npsargs );

}


/**
////////////////////////////////////////////////////////////////////////////////
///////////////////////////send Reply///////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/

bool Net_sendReply(netaddr_t dest,uint8_t counter,uint8_t feld[]) {
	netpacket_send_args_t npsargs;
	
   

	// fill structure with default values
	Net_sendArgsInit_1( &npsargs );

    uint8_t *pointer;
    pointer= feld;
    
    uint8_t counter1;	
	counter1=counter;



	npsargs.netheader.destination = dest;
	
 //----fill Array-----
	
    uint8_t x;
    for(x=0;x<=ARRAYLAENGE;x++){
        if(feld[x]==0){
              feld[x] = Configuration.id;
              break;
            }     
     
     }
//   send array     
     uint8_t s=0;
     uint8_t k;
     for(k=0; k<=ARRAYLAENGE; k++){
         npsargs.netheader.away[s]=feld[k];     
         s++;     
    }                  
     
// send to the node, the in front from own id stands     
    bool wahr = true;
    
    while(wahr){
             if(*pointer == Configuration.id){
                     *pointer--;
                     npsargs.netheader.to =((netaddr_t)*pointer);
                     wahr=false;
                     
                     }
              else {
                     *pointer++;  
                      }     
             }
        
	counter1++;
	npsargs.netheader.counter=counter1;
	
	npsargs.netheader.type = DSR_REPLY_PACKET;		// application protocol
	npsargs.netheader.flags = 0;					// network layer config flags (CRC
     
	// queue packet for sending
	return Net_send( &npsargs );
  
}


/**
////////////////////////////////////////////////////////////////////////////////
/////////////////////////////send Reply further/////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/

void handle_Reply(netaddr_t dest,uint8_t counter,uint8_t feld[]) {
	netpacket_send_args_t npsargs;

   
   
uint8_t i=0;
uint8_t j;  


//if reply source node has reached, display the list, the number of the nodes
// and the function Net_sendData() call around data to send      
   if(feld[0] == Configuration.id){
           
           for(j=0; j<=ARRAYLAENGE; j++){
               help_array[i]=feld[j];     
               i++;     
               }
               
             uint8_t l; 
           for(l=0;l<=counter;l++){
                                                     
               printf("The_way: %d\n", feld[l]);
               
         }        
            printf("Die Anzahl der Knoten ist : %d\n",counter);     
            copy_dest = dest;
            
            Net_sendData();
                      
   } 
    
    // else sent the reply further
    else{   
   

	// fill structure with default values
	Net_sendArgsInit_1( &npsargs );
      
	// fill network header custom 
	uint8_t *pointer;
    pointer= feld;

    
    
     uint8_t s=0;
     uint8_t k;
     for(k=0; k<=ARRAYLAENGE; k++){
         npsargs.netheader.away[s]=feld[k];     
         s++;     
    }          



   // send to the node, the in front from own id stands                 
    bool wahr = true;
    
    while(wahr){
             if(*pointer == Configuration.id){
                      
                     *pointer--;
                     npsargs.netheader.to =((netaddr_t)*pointer);
                     wahr=false;
                     
                     }
              else {
                     *pointer++;  
              
                    } 
                     
             }
                 
    
    npsargs.netheader.destination = dest;
    npsargs.netheader.counter=counter;
    
	
	 npsargs.netheader.type = DSR_REPLY_PACKET;		// application protocol
	 npsargs.netheader.flags = 0;					// network layer config flags (CRC
   
       
	// queue packet for sending
	return Net_send( &npsargs );
   
 }
 
}


///////////////////////////////////////////////////////////////////////////////
///////////////To decisions data further send or confirming////////////////////
///////////////////////////////////////////////////////////////////////////////
bool Decides_data(netaddr_t dest,uint8_t* data,uint8_t feld[]) {



	if(dest == Configuration.id)
	{
           Net_sendAck(feld);
            printf("bis decide ack %d\n");
            //break;
    }else{
            handle_Data(dest,data,feld);
            printf("bis decide data %d\n");          
          }
          
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////Send Data ////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


bool Net_sendData(){
netpacket_send_args_t npsargs;
// fill structure with default vallue
    Net_sendArgsInit_1( &npsargs );
     
     printf("kopierte %d\n");
     
// send array          
     uint8_t s=0;
     uint8_t k;
     for(k=0; k<=ARRAYLAENGE; k++){
         npsargs.netheader.away[s]=help_array[k];     
         s++;     
    }     
     
        
// send to the next node in array   
   uint8_t l; 
    for(l=0;l<=ARRAYLAENGE;l++){
               if(help_array[l] == Configuration.id){
                  l++;              
                  npsargs.netheader.to =((netaddr_t)help_array[l]);
                  break;               
                }                    
               
         }    
   
   
 npsargs.netheader.destination = copy_dest;    
 npsargs.netheader.type = DATA_PACKET;		// application protocol
 npsargs.netheader.flags = 0;					// network layer config flags (CRC
     
          
// data

uint8_t* data = "hello world!";

// send data
npsargs.payload[0].buffer = (uint8_t*) data;
npsargs.payload[0].size = strlen(data);
     
     
     
     
	// queue packet for sending
return Net_send( &npsargs );
   //printf("bis  Ende handle reply %d\n"); 
         
        
}     

////////////////////////////////////////////////////////////////////////////////
/////////////////// send Data Packet further////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

bool handle_Data(netaddr_t dest,uint8_t* data,uint8_t feld[]){
     
    netpacket_send_args_t npsargs;

	// fill structure with default values
	Net_sendArgsInit_1( &npsargs );
     
     //printf("Test %d\n");
     
// send array     
     uint8_t s=0;
     uint8_t k;
     for(k=0; k<=ARRAYLAENGE; k++){
         npsargs.netheader.away[s]=feld[k];     
         s++;     
    }          

     
     
// sent to next node in array  
   uint8_t l; 
    for(l=0;l<=ARRAYLAENGE;l++){
               if(feld[l] == Configuration.id){
                  l++;              
                  npsargs.netheader.to =((netaddr_t)feld[l]);
                  break;               
                }                    
 
 
         }    
         
     
 npsargs.netheader.destination=dest;    
 npsargs.netheader.type = DATA_PACKET;		// application protocol
 npsargs.netheader.flags = 0;					// network layer config flags (CRC
     
     
// send data further     
uint8_t* data = *data;


npsargs.payload[0].buffer = (uint8_t*) data;
npsargs.payload[0].size = strlen(data);
     
     
	// queue packet for sending
return Net_send( &npsargs );
   //printf("bis  Ende handle reply %d\n"); 
         
        
}     



////////////////////////////////////////////////////////////////////////////////
//////////////////////send confirming //////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

bool Net_sendAck(uint8_t feld[]){
     
    netpacket_send_args_t npsargs;

	// fill structure with default values
	Net_sendArgsInit_1( &npsargs );


// Ack agrees of the source node so only of 
//the source node can display this printf
   if(feld[0]==Configuration.id){  
                                      
   printf("Bestaetigung %d\n");
   printf("Ich habe die Daten erhalten %d\n");
   
   }
// send array   
     uint8_t s=0;
     uint8_t k;
     for(k=0; k<=ARRAYLAENGE; k++){
         npsargs.netheader.away[s]=feld[k];     
         s++;     
         }     
     
     
     
 // send to the node, the in front from own id stands   
   uint8_t l; 
    for(l=0;l<=ARRAYLAENGE;l++){
               if(feld[l] == Configuration.id){
                  l--;              
                  npsargs.netheader.to =((netaddr_t)feld[l]);
                  break;               
                }                    
               
         }    
     
     
 npsargs.netheader.type = ACK_PACKET;		// application protocol
 npsargs.netheader.flags = 0;			// network layer config flags (CRC
     
        
	// queue packet for sending
return Net_send( &npsargs );
   
         
        
 }     


     

